Bug 1906368 - python-semver fails to build with Python 3.10: TypeError: VersionInfo.__init__() got an unexpected keyword argument 'unknown' [NEEDINFO]
Summary: python-semver fails to build with Python 3.10: TypeError: VersionInfo.__init_...
Keywords:
Status: POST
Alias: None
Product: Fedora
Classification: Fedora
Component: python-semver
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Lumír Balhar
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10 1919795
TreeView+ depends on / blocked
 
Reported: 2020-12-10 11:48 UTC by Tomáš Hrnčiar
Modified: 2021-02-16 09:45 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug
thrnciar: needinfo? (igor.raits)


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2020-12-10 11:48:12 UTC
python-semver fails to build with Python 3.10.0a3.


=================================== FAILURES ===================================
_____________________________ [doctest] usage.rst ______________________________
446    True
447 
448   The opposite does also work::
449 
450    >>> dict(major=1) < v
451    True
452 
453   If the dictionary contains unknown keys, you get a :class:`TypeError` exception::
454 
455     >>> v > dict(major=1, unknown=42)
Differences (ndiff with -expected +actual):
      Traceback (most recent call last):
    - ...
    +   File "/usr/lib64/python3.10/doctest.py", line 1340, in __run
    +     exec(compile(example.source, filename, "single",
    +   File "<doctest usage.rst[75]>", line 1, in <module>
    +     v > dict(major=1, unknown=42)
    +   File "/builddir/build/BUILD/python-semver-2.13.0/semver.py", line 203, in wrapper
    +     return operator(self, other)
    +   File "/builddir/build/BUILD/python-semver-2.13.0/semver.py", line 589, in __gt__
    +     return self.compare(other) > 0
    +   File "/builddir/build/BUILD/python-semver-2.13.0/semver.py", line 495, in compare
    +     other = cls(**other)
    - TypeError: __init__() got an unexpected keyword argument 'unknown'
    + TypeError: VersionInfo.__init__() got an unexpected keyword argument 'unknown'
    ?            ++++++++++++

/builddir/build/BUILD/python-semver-2.13.0/docs/usage.rst:455: DocTestFailure
=========================== short test summary info ============================
FAILED docs/usage.rst::usage.rst
======================== 1 failed, 318 passed in 0.86s =========================

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01822238-python-semver/

For all our attempts to build python-semver with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-semver/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Tomáš Hrnčiar 2021-01-20 15:15:33 UTC
Hello, is there any update on this? It blocks testing of 8 other packages (mu, hatch, pipenv, python-natsort, python-nikola, python-paperwork-backend, python-xbout, python-pytenable) with Python 3.10. Thank you.

Comment 2 Ben Cotton 2021-02-09 15:33:11 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 34 development cycle.
Changing version to 34.


Note You need to log in before you can comment on or make changes to this bug.